% !TeX spellcheck = en_US
% !TeX encoding = UTF-8
% !TeX root = ../report.tex

% Operators
\DeclareMathOperator*{\argmax}{arg\,max}
\DeclareMathOperator*{\argmin}{arg\,min}
\DeclareMathOperator*{\maxopnew}{max}
\DeclareMathOperator*{\minopnew}{min}


% Reference systems macros
\newcommand{\x}{\mathsf{x}}
\newcommand{\y}{\mathsf{y}}
\newcommand{\z}{\mathsf{z}}

\newcommand{\gref}{\mathcal{G}} 
\newcommand{\vref}{\mathcal{V}}
\newcommand{\tref}{\mathcal{T}}


% Macros
\newcommand{\acc}{a} % acceleration
\newcommand{\latacc}{\acc_\y} % lateral acceleration
\newcommand{\longacc}{\acc_\x} % longitudinal acceleration
%\newcommand{\exV}{\mathbf{e}_\mathsf{x}^\vref} % unit vector ex in V
%\newcommand{\eyV}{\mathbf{e}_\mathsf{y}^\vref} % unit vector ey in V
%\newcommand{\ezV}{\mathbf{e}_\mathsf{z}^\vref} % unit vector ez in V
\newcommand{\exV}{\mathbf{x}_\vref} % unit vector ex in V
\newcommand{\eyV}{\mathbf{y}_\vref} % unit vector ey in V
\newcommand{\ezV}{\mathbf{z}_\vref} % unit vector ez in V
\newcommand{\OV}{O_\vref} % origin of V
\newcommand{\exG}{\mathbf{x}_\gref} % unit vector ex in G
\newcommand{\eyG}{\mathbf{y}_\gref} % unit vector ey in G
\newcommand{\ezG}{\mathbf{z}_\gref} % unit vector ez in G
\newcommand{\OG}{O_\gref} % origin of G
%\newcommand{\exT}[1]{\mathbf{e}_\mathsf{x}^{\tref_{#1}}} % unit vector ex in Tij
%\newcommand{\eyT}[1]{\mathbf{e}_\mathsf{y}^{\tref_{#1}}} % unit vector ey in Tij
%\newcommand{\ezT}[1]{\mathbf{e}_\mathsf{z}^{\tref_{#1}}} % unit vector ez in Tij


\newcommand{\exT}[1]{\mathbf{x}_{\tref_{#1}}} % unit vector ex in Tij
\newcommand{\eyT}[1]{\mathbf{y}_{\tref_{#1}}} % unit vector ey in Tij
\newcommand{\ezT}[1]{\mathbf{z}_{\tref_{#1}}} % unit vector ez in Tij
\newcommand{\OT}[1]{O_{\tref_{#1}}} % origin of Tij
%\newcommand{\norm}[1]{\left\lvert#1\right\rvert}
\newcommand{\inG}[1]{{_{\gref}}{#1}}
\newcommand{\inV}[1]{{_{\vref}}{#1}}
\newcommand{\inT}[1]{{_{\tref_{ij}}}{#1}}
\newcommand{\tGV}{\mathbf{t}^{\mathcal{G}}_{\mathcal{V}}}
\newcommand{\tVT}{\mathbf{t}^{\mathcal{V}}_{\mathcal{T}_{ij}}}
\newcommand{\TGV}{T^{\mathcal{G}}_{\mathcal{V}}}
\newcommand{\TVT}{T^{\mathcal{V}}_{\mathcal{T}_{ij}}}
\newcommand{\RGV}{R^{\mathcal{G}}_{\mathcal{V}}}
\newcommand{\RVT}{R^{\mathcal{V}}_{\mathcal{T}_{ij}}}
\newcommand{\rGP}{{_\mathcal{G}}\mathbf{r}_{P}}
\newcommand{\rVP}{{_\mathcal{V}}\mathbf{r}_{P}}
\newcommand{\rTP}{{_{\mathcal{T}_{ij}}}\mathbf{r}_{P}}



\newcommand{\velocity}{\mathcal{V}}
\newcommand{\occupancyGrid}{\mathcal{O}}
\newcommand{\trust}{\Psi}

\newcommand{\posterior}{p}
\newcommand{\odds}{o}
\newcommand{\measObs}{m}
\newcommand{\motorsIF}{\mathcal{I}_M}
\newcommand{\brakesIF}{\mathcal{I}_B}
\newcommand{\pThrottle}{p_{\mathrm{Throttle}}}
\newcommand{\pThrottleL}{p_{\mathrm{Throttle}_L}}
\newcommand{\pThrottleR}{p_{\mathrm{Throttle}_R}}
\newcommand{\pBrakes}{p_{\mathrm{Brakes}}}

\newcommand{\scoringFunction}{f_{\mathrm{Scoring}}}
\newcommand{\scoringFunctionTotal}{f_{\mathrm{Scoring}_{\mathrm{total}}}}
\newcommand{\controllerSubs}{\mathrm{Controller}}
\newcommand{\scoringFunctionArguments}{\scoringFunction \left(\trajectory, \occupancyGrid \right)}

\newcommand{\activationFunction}{f_{\mathrm{act}}}

\newcommand{\costJ}{\mathcal{J}}
\newcommand{\costJSet}{\left\{\costJ_0, \costJ_1, \dots, \costJ_N\right\}}
\newcommand{\costJs}{\pmb{\mathcal{J}}}
\newcommand{\costJCtrl}{\mathcal{J}_{\controllerSubs}}
\newcommand{\costJsCtrl}{\pmb{\mathcal{J}}_{\controllerSubs}}

\newcommand{\tDelay}{t_{\mathrm{delay}}}

\newcommand{\scenFunc}{s}
\newcommand{\scenFuncStatic}{\scenFunc_{\mathrm{static}}}
\newcommand{\scenFuncFull}{\scenFunc\left( \gokartState(t),t\right)}
\newcommand{\scenFuncStaticFull}{\scenFuncStatic\left( \gokartState(t),t, \tDelay\right)}
\newcommand{\scenFuncStaticFullIpt}{\scenFuncStatic\left( \gokartState(t),t, \tDelay, \gokartInput_{previous} \right)}
\newcommand{\setS}{\pmb{s}}
\newcommand{\scenSet}{\left\{\scenFunc_0, \scenFunc_1, \dots, \scenFunc_N\right\}}

\newcommand{\dynFunc}{f_{\mathrm{dyn}}}
\newcommand{\dynFuncFull}{\dynFunc\left( \gokartState(t) ,\ \gokartInput(t)\right)}
\newcommand{\dynFuncFullScen}{\dynFunc\left( \gokartState(t) ,\ \scenFuncFull\right)}
\newcommand{\dynFuncFullInt}[2]{\int_{#1}^{#2}\dynFuncFull dt}

\newcommand{\locFunc}{f_{\mathrm{loc}}}
\newcommand{\pointcloud}{p}

\newcommand{\predFunc}{\rho}
\newcommand{\predFuncScen}{\rho_{\scenFunc}}

\newcommand{\dynFuncFullDisc}{\dynFunc\left( \gokartState[k] ,\ \gokartInput[k]\right)}
\newcommand{\dynFuncFullIntDisc}[2]{\int_{#1}^{#2}\dynFuncFullDisc}

\newcommand{\gokartState}{\pmb{x}}
\newcommand{\gokartStateCtrl}{\gokartState_{\controllerSubs}}
\newcommand{\gokartStates}{\tau}
\newcommand{\gokartStateInit}{\gokartState_0}
\newcommand{\gokartStateSet}{\left\{\gokartState_0, \gokartState_1, \dots, \gokartState_N\right\}}
\newcommand{\gokartStateSetTime}{\left\{\langle t_0, \gokartState(t_0)\rangle, \langle t_0, \gokartState(t_1)\rangle, \dots, \langle t_N, \gokartState(t_N)\rangle\right\}}

\newcommand{\gokartStatePred}{\gokartState_{pred}[k+1]}

\newcommand{\gokartDelay}{d}
\newcommand{\gokartDelaySet}{\left\{\gokartDelay_1, \gokartDelay_2, \dots, \gokartDelay_N\right\}}
\newcommand{\gokartDelays}{\pmb{\gokartDelay}}

\newcommand{\gokartPosition}{\Vec{x}}
\newcommand{\extractPosition}{\mathcal{X}}
\newcommand{\gokartVelocity}{\Vec{v}}
\newcommand{\extractVelocity}{\mathcal{V}}

\newcommand{\gokartInput}{\pmb{u}}
\newcommand{\gokartInputCtrl}{\gokartInput_{\controllerSubs}}
\newcommand{\gokartInputs}{\gokartInput_{0:N}}
\newcommand{\gokartInputsCtrl}{\gokartInput_{\controllerSubs}}
\newcommand{\gokartInputSet}{\left\{\gokartInput_0, \gokartInput_1, \dots, \gokartInput_N\right\}}
\newcommand{\gokartInputSetTime}{\left\{\langle t_0, \gokartInput(t_0)\rangle, \langle t_1, \gokartInput(t_1)\rangle, \dots, \langle t_N, \gokartInput(t_N) \rangle\right\}}
\newcommand{\gokartInputStatic}{\gokartInput_{\mathrm{static}}}

\newcommand{\gokartObs}{o}
\newcommand{\gokartObsSet}{\left\{\gokartInput_0, \gokartInput_1, \dots, \gokartInput_N\right\}}
\newcommand{\gokartObsSetprev}{\left\{\gokartInput_{K}, \gokartInput_{-K+1}, \dots, \gokartInput_{-1}, \gokartInput_0\right\}}


\newcommand{\trajectory}{\gokartStates}
\newcommand{\trajectoryCtrl}{\gokartStates_{\controllerSubs}}
\newcommand{\trajectorySet}{\mathcal{T}}
\newcommand{\trajectoryCtrlSet}{\trajectorySet_{\controllerSubs}}
\newcommand{\trajectoryCtrlSetNew}{\trajectorySet_{\controllerSubs_{\mathrm{new}}}}

\newcommand{\conservativeness}{\mathcal{C}}
\newcommand{\conservativenessFunction}{f_{\mathcal{C}}}
\newcommand{\trustMetric}{f_{\trust}}
\newcommand{\gokartInputsCons}{\gokartInput_{\conservativeness}}
\newcommand{\trajectoryCons}{\trajectory_{\conservativeness}}
\newcommand{\gokartInputConsSet}{\left\{\gokartInput_0, \gokartInput_1, \dots, \gokartInput_{\conservativeness}\right\}}
\newcommand{\gokartStateConsSet}{\left\{\gokartState_0, \gokartState_1, \dots, \gokartState_{\conservativeness}\right\}}


% Special groups
\newcommand{\SE}[1]{\mathsf{SE(#1)}} % special euclidean group
\newcommand{\SO}[1]{\mathsf{SO(#1)}} % special rotation group

% Numbers
\newcommand{\reals}{\mathbb{R}}
\newcommand{\realsab}[2]{\mathbb{R}^{#1\times#2}}
\newcommand{\boolsab}[2]{\mathbb{B}^{#1\times#2}}
\newcommand{\bools}{\mathsf{Bool}}


% Guardian Angel
\newcommand{\ga}{\textsc{GA}}


\newcommand{\az}[1]{\todo[inline]{#1}}


% Colors
\definecolor{rvizDarkGreen}{RGB}{0, 170, 0}
\definecolor{rvizLightGreen}{RGB}{25, 255, 0}
\definecolor{rvizLightBlue}{RGB}{0, 170, 255}
\definecolor{rvizDarkBlue}{RGB}{0, 0, 255}
\definecolor{rvizPink}{RGB}{255, 85, 255}
\definecolor{rvizRed}{RGB}{255, 0, 0}

